/*
 * set-alarm.js
 *
 * Copyright (c) 2004, 2005 by Daniel Potter.  All rights reserved.
 *
 * This file is part of the Vana'diel Clock.
 *
 * The Vana'diel Clock is free software; you can redistribute
 * it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * The Vana'diel Clock is distributed in the hope that it will
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the Vana'diel Clock; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA  02111-1307  USA
 *
 * Handles the UI for setting an alarm.
 */

var rseRaces = ['elvaan.male', 'elvaan.female',
	'tarutaru.male', 'tarutaru.female',
	'mithra', 'galka', 'hume.male', 'hume.female' ];

function init() {
    var x = Math.floor((window.opener.outerWidth - window.outerWidth) / 2 + window.opener.screenX);
    var y = Math.floor((window.opener.outerHeight - window.outerHeight) / 2 + window.opener.screenY);
    window.moveTo(x, y);
}

function acceptChanges() {
    // See what type of alarm was selected.
    var type = document.getElementById("type-tabbox").selectedTab.getAttribute("id");
    var time = 0;
    var respawn = 0;
    // grab the current time
    var vanadielTime = Math.floor(((new Date().getTime() - vanadielOffset) * 25) / 1000);
    if (type == "day-tab") {
	// Create a new alarm based on the day.
	var dayName = document.getElementById("day-dropdown").selectedItem.getAttribute("element");
	var day = -1;
	// convert that day back to a number
	for (var d in vanaDays) {
	    if (dayName == vanaDays[d]) {
		day = d;
		break;
	    }
	}
	if (day < 0) {
	    alert("Unknown day " + dayName);
	    return;
	}
	time = vanadielTime - (vanadielTime % 691200);
	time += day * 86400;
	// if we're in the past, jump to the next week
	if (time < vanadielTime)
	    time += 691200;
	respawn = 691200;
    } else if (type == "moon-tab") {
	// Create a new alarm based on the moon phase.
	var phase = document.getElementById("moon-dropdown").selectedItem.getAttribute("phase");
	alert("These aren't implemented yet.");
	return;
    } else if (type == "rse-tab") {
	alert("These aren't implemented yet.");
	return;
    } else if (type == "guild-tab") {
	alert("These aren't implemented yet.");
	return;
    } else {
	alert("You managed to choose an alarm type (" + type + ") that isn't listed.  Have a cookie!  But no alarm will be set, sorry.");
	return;
    }
    if (time < vanadielTime) {
	alert("Error: alarm set to " + time + " but current time is " + vanadielTime + ": assuming something is wonky and aborting.");
	return;
    }
    dump("Creating an alarm at " + time + " (current time is " + vanadielTime + ")\n");
    var alarm = new Alarm(time);
    var alarms = loadAlarms();
    alarms.push(alarm);
    saveAlarms(alarms);
    var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].
		getService(Components.interfaces.nsIWindowMediator);
    var windowEnum = windowManager.getEnumerator(null);
    while (windowEnum.hasMoreElements()) {
	var win = windowEnum.getNext();
	if (win.vanadielOffset && win.updateAlarms) {
	    win.updateAlarms();
	}
    }
}
